;
; Copyright 2005, 2006 University of Leiden.
;
; This file is part of MIA+EWS.
;
; MIA+EWS is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; MIA+EWS is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with MIA; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;

THIS IS TOTALLY OUTDATED, CONTAINS DOZENS OF NASTY BUGS AND SHOULD NOT BE USED!

;
; xmidivisi.pro
; Created:     Thu Jun 12 01:13:57 2003 by Koehler@rommie
; Last change: Fri Jan 28 15:11:18 2005
;
; PURPOSE:
;	save the world (or a small part of it)
;
; CALLING SEQUENCE:
;	xmidivisi, fringefile, photfileA, photfileB
;	(there are more options, use the source!)
;
; INPUT:
;	fringefile:	MIDI file with fringe search or track data
;	photfileA/B:	MIDI files with chopping data, shutter A/B
;			open, respectively.
;
; OUTPUT:
;	interactive plot of fringe amplitudes
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

PRO xmidivisi_plot_static
  COMMON xmidivisi, scanLength, longwl, shortwl, $
    opd, flux1, flux2, fringe, foufri, amplfou, $
    xhist, hist, meanramp, noiseramp, $
    object, fringefile, photfiles, maskfile, $
    goodthresh, oldgthres, goodfringes, Ngood, $
     badthresh, oldbthres,  badfringes, Nbad,  button

  plot, opd,     xtitle = "Frame no.", title= "Optical Path Difference"
  plot, fringe,  xtitle = "Frame no.", title= "Raw Amplitude"

  maxflux= max( [ flux1, flux2 ] )
  minflux= min( [ flux1, flux2 ] )
  plot, flux1, yrange=[minflux,maxflux], xtitle = "Frame no.", title = "Fluxes"
  oplot,flux2, linestyle=1
  multi = !P.multi

  plot, amplfou, xtitle = "Scan no.", title = "Fourier Fringe Amplitude (linear)"
  if (Ngood gt 1) then begin
      oplot,goodfringes,replicate(oldgthres,Ngood),psym=3,color=0
      oplot,goodfringes,replicate(oldbthres,Ngood),psym=3,color=0
  endif
  !p.charsize= 1.0
  !P.multi = multi
end

PRO xmidivisi_plot_goodbad
  COMMON xmidivisi, scanLength, longwl, shortwl, $
    opd, flux1, flux2, fringe, foufri, amplfou, $
    xhist, hist, meanramp, noiseramp, $
    object, fringefile, photfiles, maskfile, $
    goodthresh, oldgthres, goodfringes, Ngood, $
     badthresh, oldbthres,  badfringes, Nbad,  button

  !p.charsize= 1.
  if (Ngood gt 0) then begin
      goodfou = foufri[*,goodfringes]
      plot, goodfou[*,0], yrange=[0,max(foufri)], $
        title="Good Fringes", xtitle= "Frequency", ytitle="Spectral Power"
      for f=1,Ngood-1 do oplot, goodfou[*,f]

      totopd = abs(opd[scanLength-1,goodfringes[0]]-opd[0,goodfringes[0]])*1e6
      lowfreq = floor(totopd/longwl+0.5)
      highfreq= floor(totopd/shortwl+0.5)
      if (highfreq gt scanLength/2) then highfreq= scanLength/2
      oplot,[ lowfreq, lowfreq],[0,max(foufri)],linestyle=2
      oplot,[highfreq,highfreq],[0,max(foufri)],linestyle=2

      if (Ngood gt 1) then begin
          totfou = total(goodfou,2) / Ngood
          oplot, totfou, color=100
      endif
  endif
  if (Nbad gt 0) then begin
      badfou = foufri[*,badfringes]
      plot, badfou[*,0], yrange=[0,max(foufri)], $
        title="Bad Fringes", xtitle= "Frequency", ytitle="Spectral Power"
      for f=1,Nbad-1 do oplot, badfou[*,f]

      if (Nbad gt 1) then begin
          totfou = total(badfou,2) / Nbad
          oplot, totfou, color=100
      endif
  endif
end

PRO xmidivisi_plot_histogram
  COMMON xmidivisi, scanLength, longwl, shortwl, $
    opd, flux1, flux2, fringe, foufri, amplfou, $
    xhist, hist, meanramp, noiseramp, $
    object, fringefile, photfiles, maskfile, $
    goodthresh, oldgthres, goodfringes, Ngood, $
     badthresh, oldbthres,  badfringes, Nbad,  button

  plot, xhist,meanramp,title="Mean amplitude as function of threshold",ystyle=2
  oplot,xhist,noiseramp,linestyle=1
  plot, xhist,hist, title="Histogram of Fourier-Amplitudes",$
    ystyle=2, psym=10
  oplot, [goodthresh,goodthresh], [0,max(hist)*1.2]
  oplot, [ badthresh, badthresh], [0,max(hist)*1.2], linestyle=1
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
PRO xmidivisi_event, ev

;print,"event!"
  COMMON xmidivisi, scanLength, longwl, shortwl, $
    opd, flux1, flux2, fringe, foufri, amplfou, $
    xhist, hist, meanramp, noiseramp, $
    object, fringefile, photfiles, maskfile, $
    goodthresh, oldgthres, goodfringes, Ngood, $
     badthresh, oldbthres,  badfringes, Nbad,  button

  WIDGET_CONTROL, ev.TOP, GET_UVALUE=st

  update = 0
  ; draw when our initial event comes
  if (TAG_NAMES(ev, /STRUCTURE_NAME) EQ 'WIDGET_TIMER') then update=1
  case (ev.ID) OF
      st.frimov: xmidimovie, opd, fringe
      st.foumov: xmidimovie, findgen(scanLength), foufri
      st.print:  update = 1	; force update to recompute visibility
      st.wrtlog: update = 1	; force update to recompute visibility
      st.rgtdraw: begin
          if (ev.type eq 0) then button= ev.press
          if (ev.type eq 1) then button= 0
          if (ev.type eq 0 or (ev.type eq 2 and button ne 0)) then begin
              pos = convert_coord( ev.x, ev.y, /DEVICE, /TO_DATA)
                                ;print, "data pos: ",pos
              case button of
                  1:  goodthresh = pos[0]
                  else: badthresh= pos[0]
              endcase
              update = 1
          endif
      end
      st.quit: begin
          WIDGET_CONTROL, ev.TOP, /DESTROY
          return
      end
      else: ;relax
  endcase

  if (update eq 0) then return

  ;;;;; plot fourier fringe amplitude and thresholds

  wset, st.topdrawID
  !p.multi= st.multi
  !p.charsize= 1.7
  plot, amplfou, xtitle = "Scan no.", title = "Fourier Fringe Amplitude (linear)"
  if (Ngood gt 1) then begin
      oplot,goodfringes,replicate(oldgthres,Ngood),psym=3,color=0
      oplot,goodfringes,replicate(oldbthres,Ngood),psym=3,color=0
  endif
  goodfringes= where(amplfou gt goodthresh, Ngood)
  badfringes = where(amplfou lt badthresh,  Nbad)
                                ;print,Ngood," good fringes"
  if (Ngood gt 1) then begin
      oplot,goodfringes,replicate(goodthresh,Ngood),psym=3
      oplot,goodfringes,replicate(badthresh,Ngood),psym=3
      oldgthres= goodthresh
      oldbthres= badthresh
  endif

  if (Ngood gt 1) then begin
      mom = moment(amplfou[goodfringes])
      good_ampl = mom[0]
      good_var  = mom[1]
  endif else if (Ngood gt 0) then begin
      good_ampl = amplfou[goodfringes[0]]
      good_var  = 0.
  endif else begin
      good_ampl = 0. & good_var = 0.
  endelse

  if (Nbad gt 1) then begin
      mom = moment(amplfou[badfringes])
      bad_ampl = mom[0]
      bad_var  = mom[1]
  endif else if (NBad gt 0) then begin
      bad_ampl = amplfou[badfringes[0]]
      bad_var  = 0.
  endif else begin
      bad_ampl = 0. & bad_var = 0.
  endelse

  fringe_ampl    = sqrt(good_ampl*good_ampl - bad_ampl*bad_ampl)
  fringe_ampl_err= sqrt(good_ampl*good_ampl*good_var + bad_ampl*bad_ampl*bad_var) / fringe_ampl
  correl_flux    = fringe_ampl     * 145./st.DIT
  correl_flux_err= fringe_ampl_err * 145./st.DIT
  flux_factor	 = 2d * (sqrt(st.FluxA1*st.FluxB1) + sqrt(st.FluxA2*st.FluxB2))
  visibility     = correl_flux     / flux_factor
  visibility_err = correl_flux_err / flux_factor

  Widget_Control, st.goodthl,SET_Value="Good threshold:"+string(goodthresh)
  Widget_Control, st.badthl ,SET_Value=" Bad threshold:"+string( badthresh)
  Widget_Control, st.sigamp, SET_VALUE="Mean signal ampl. "+strtrim(string(good_ampl),2)
  Widget_Control, st.noiamp, SET_VALUE="Mean noise  ampl. "+strtrim(string( bad_ampl),2)
  Widget_Control, st.corramp,SET_VALUE="Corrected amplit. "+strtrim(string(fringe_ampl),2)
  Widget_Control, st.corrflx,SET_VALUE="Correlated flux "+$
    strtrim(string(correl_flux,format='(G10.3)'),2)
  Widget_Control, st.visibi, SET_VALUE="VISIBILITY = "+$
    strtrim(string(visibility,format='(F6.4)'),2)+"+-"+$
    strtrim(string(visibility_err,format='(F6.4)'),2)

  ;;;;; plot the good, the bad, and the ugly

  wset, st.lftdrawID
  !P.multi = [ 0,0,2,0,0 ]
  xmidivisi_plot_goodbad

  ;;;;; plot histogram

  wset,st.rgtdrawID
  !P.multi = [0,0,2,0,0]
  xmidivisi_plot_histogram

  ;;;;; create hardcopy, if button pressed

  if (ev.ID eq st.print) then begin
      first_char = STRPOS(fringefile,'/MIDI.20')+6
      last_char  = STRPOS(fringefile,'.fits')
      short_fname= STRMID(fringefile,first_char,last_char-first_char)

      xmargin_saved = !X.Margin
      set_plot,"PS"
      device,filename="./Midivisi"+short_fname+".ps",/Landscape

      !P.multi= [ 8, 1, 8, 0, 0 ]
      xmidivisi_plot_static

      !P.multi= [ 6, 2, 4, 0, 1 ]
      !X.Margin[1] = 30
      xmidivisi_plot_goodbad

      !P.multi= [ 2, 2, 4, 0, 1 ]
      !X.Margin[0] = 35 & !X.Margin[1] = xmargin_saved[1]
      xmidivisi_plot_histogram

      !P.multi= [ 1, 1, 1, 0, 1 ]
      device,font_size=10
      nScan = N_elements(amplfou)
      XYOuts, 0.5, 0.45, "Object: "+Object, Alignment=0.5, /NORMAL
      XYOuts, 0.5, 0.42, "Photom.Filter: "+st.PhFilt, Alignment=0.5,/Normal
      XYOuts, 0.5, 0.39, "Fringe Filter: "+st.FrFilt, Alignment=0.5,/Normal
      XYOuts, 0.5, 0.36, "Scanlength "+strtrim(string(scanlength),2)+$
        " => "+strtrim(string(nScan),2)+" scans", Alignment=0.5,/Normal
      XYOuts, 0.5, 0.33, "Beam is "+st.beam, Alignment=0.5,/Normal
      fluxstr= string( st.FluxA1, st.FluxA2, Format='("A: ",G0.3,", ",G0.3," ph/sec")')
      XYOuts, 0.5, 0.30, fluxstr, Alignment=0.5,/Normal
      fluxstr= string( st.FluxB1, st.FluxB2, Format='("B: ",G0.3,", ",G0.3," ph/sec")')
      XYOuts, 0.5, 0.27, fluxstr, Alignment=0.5,/Normal

      XYOuts, 0.5, 0.23, "Good threshold:"+string(goodthresh), Alignment=0.5,/Normal
      XYOuts, 0.5, 0.20, " Bad threshold:"+string( badthresh), Alignment=0.5,/Normal

      XYOuts, 0.5, 0.16, "Mean signal ampl. "+strtrim(string(good_ampl),2)  , Alignment=0.5,/Normal
      XYOuts, 0.5, 0.13, "Mean noise  ampl. "+strtrim(string( bad_ampl),2)  , Alignment=0.5,/Normal
      XYOuts, 0.5, 0.10, "Corrected amplit. "+strtrim(string(fringe_ampl),2), Alignment=0.5,/Normal
      XYOuts, 0.5, 0.07, "Correlated Flux "+$
        strtrim(string(correl_flux,format='(G10.3)'),2), Alignment=0.5,/Normal
      XYOuts, 0.5, 0.03, "VISIBILITY = "+$
        strtrim(string(visibility,format='(F6.4)'),2)+"+-"+$
        strtrim(string(visibility_err,format='(F6.4)'),2),Alignment=0.5,/Normal

      device,/close
      set_plot,"X"
      !X.Margin = xmargin_saved
  endif

  ;;;;; write to logfile, if button was pressed

  if (ev.ID eq st.wrtlog) then begin
      if not file_test("PHOTOMETRY") then spawn,'mkdir "PHOTOMETRY"'
      openw, lun, "PHOTOMETRY/visibilities",/get_lun,/append
      printf,lun, "Object: ",object
      printf,lun, "Fringefile(s):" & printf,lun,fringefile
      printf,lun, "Photfile(s):  " & printf,lun,photfiles
      printf,lun, "Maskfile:   ",maskfile
      printf,lun, "Noise threshold:",badthresh,", Signal threshold:",goodthresh
      printf,lun, "Mean signal ampl. "+strtrim(string(good_ampl),2)
      printf,lun, "Mean noise  ampl. "+strtrim(string( bad_ampl),2)
      printf,lun, "Corrected amplit. "+strtrim(string(fringe_ampl),2)
      printf,lun, "Correlated flux "+strtrim(string(correl_flux,format='(G10.3)'),2)
      printf,lun, "VISIBILITY = " + strtrim(string(visibility,format='(F8.6)'),2) + $
        "+-" + strtrim(string(visibility_err,format='(F8.6)'),2)
      printf,lun, "----------------------------------------------------------------------"
      close, lun & free_lun, lun
  endif
END

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

PRO xmidivisi, fringefile_in, photfileA, photfileB, MASKFILE=maskfile_in, $
               SKY=sky, ASKY=skyA, BSKY=skyB, $
               THRESHOLD=threshold, MOVIE=movie, NOFOU=nofou, NOPOSCHECK=noposcheck,$
               OPD=retopd, FRINGE=retfringe, FOUFRI=retfoufri

  COMMON xmidivisi, scanLength, longwl, shortwl, $
    opd, flux1, flux2, fringe, foufri, amplfou, $
    xhist, hist, meanramp, noiseramp, $
    object, fringefile, photfiles, maskfile, $
    goodthresh, oldgthres, goodfringes, Ngood, $
     badthresh, oldbthres,  badfringes, Nbad,  button


  fringefile= fringefile_in[0]
  photfileA = photfileA[0]

  !X.style = 1
  !Y.style = 1
  button = 0

    first_char    = STRPOS(fringefile,'/MIDI.20')+6
    last_char     = STRPOS(fringefile,'.fits')
    short_fringefile= STRMID(fringefile,first_char,last_char-first_char)

    if N_Params() gt 2  then begin
	; we have photometry A and B
        photfiles = [ photfileA, photfileB ]
        if not keyword_set(skyA) and keyword_set(sky) then skyA=sky
        read_photometry, photfileA, PhFilt, FluxA2, FluxA1, sky=skyA
        FluxA = FluxA1 + FluxA2

        if not keyword_set(skyB) and keyword_set(sky) then skyB=sky
        read_photometry, photfileB[0], PhFiltB, FluxB2, FluxB1, sky=skyB
        FluxB = FluxB1 + FluxB2

        if PhFilt ne PhFiltB then begin
            eniki= "any key"
            print, "Photometric filter A is ",PhFilt, ", but"
            print, "Photometric filter B is ",PhFiltB,"."
            read,  "Do you know what you are doing? ",eniki
            if eniki ne "y" then return
        endif
    endif else begin
        photfiles = photfileA
        read_photometry, photfileA, PhFilt, FluxA, FluxB, sky=sky
        FluxA1 = FluxA/2 & FluxA2 = FluxA1
        FluxB1 = FluxB/2 & FluxB2 = FluxB1
    endelse

    if keyword_set(maskfile_in) then maskfile = maskfile_in $
				else maskfile = make_maskname(photfileA)

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

    if not keyword_set(noposcheck) then begin
        maskfile = check_mask_position(fringefile,maskfile)
        wdelete,0
        if (maskfile eq "") then  return
    endif
    print,"Maskfile is ",maskfile
    first_char = strpos(maskfile,'/Mask_20')+1
    short_maskfile= STRMID(maskfile,first_char) ;rm path

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

    comprfile = 'PHOTOMETRY/Compr_'+short_fringefile+'_'+short_maskfile

    do_compress = 1
    if file_test(comprfile) then begin
        do_compress = 0
        print, ""
        print, "Compressed file exists already:"
        print, comprfile
        test="string" & read, "Shall I use it? [Y/n] ",test
        if (test eq 'n') then begin
            spawn, "rm "+comprfile
            do_compress = 1
        endif
    endif
    if (do_compress eq 1) then begin
        if not file_test("PHOTOMETRY") then spawn,'mkdir "PHOTOMETRY"'
        cmd = getenv("vltiCbin") + '/oirCompress "'+ $
          fringefile +'" '+ maskfile +' '+ comprfile
        print, ''
        print, cmd
        spawn, cmd
    endif
    print, ''
    print, 'getting data...'
    data = oirgetdata(comprfile)

    ; the following was (partly) stolen from midiRawFringe
    dtime = 86400. * (data[1].time[0] - data[0].time[0])
    tZero = 1.
    nZero = (tZero/dtime) > 10
    ;print,"dtime ",dtime,", nzero ",nzero

    ; we have to use the original filenames because oircompress
    ; removes all the interesting things from the header
    filename = oirFileList(fringefile)

    im = obj_new('fitsfile',filename[0])
    he = im->prihead()
    OBJECT = STRCOMPRESS(he->getpar('OBS TARG NAME'),/remove_all)
    DIT    = STRCOMPRESS(he->getpar('DET DIT'),/remove_all)
    FrFilt = STRCOMPRESS(he->getpar('INS FILT NAME'),/remove_all)
    obj_destroy,im

    ;   figure out scan size from header
    im = OBJ_NEW('imagedata', filename[0])
    scanLength = (im->head())->getpar('maxstep')

    ;   figure out channel location from OPT1
    beam = (im->prihead())->getpar('INS OPT1')
    OBJ_DESTROY,im

    nData = N_ELEMENTS(data)
    nScan = nData/scanLength
    print, nData," frames =>", nScan, " scans"
    if (beam EQ 'HIGH_SENS') then begin
        flux1 = data.data1
        flux2 = data.data2
    endif else if (beam EQ 'SCI_PHOT') then begin
        flux1 = data.data2
        flux2 = data.data3
    endif else begin
        print,"INS OPT1 is",beam
        print,"Neither HIGH_SENS nor SCI_PHOT, don't know where the fringes are!"
        return
    endelse
    fringe = flux1 - flux2

    opd = data.localOpd[1]-data.localOpd[0] + data.opd[1]-data.opd[0]

    ; 1st two points are garbage
    fringe[0:1] = MEDIAN(fringe[2:200])
    ; last two opd points are garbage
    opd[nData-2:nData-1] = median(opd[nData-scanLength:nData-2])

    ; remove low freq trend
    fringe = fringe - SMOOTH(fringe, nZero,/EDGE_TRUNCATE)

    ; reform into scans, droping last fractional scan if any
    nFringe= LONG(scanLength)*LONG(nScan)
    fringe = REFORM(fringe(0:nFringe-1), scanLength, nScan,/overwrite)
    opd    = REFORM(opd(0:nFringe-1), scanLength, nScan,/overwrite)

    foufri = fltarr(scanLength, nScan)

    amplmax= fltarr(nScan,/nozero)
    amplfou= fltarr(nScan,/nozero)

    case FrFilt of
    ; "OPEN" added by FP, wavelength range just estimated
    'OPEN':  begin print,"filter: open"  & longwl=15.  & shortwl= 7.  & end
    'Nband': begin print,"N-band filter" & longwl=13.  & shortwl= 7.7 & end
    'N8.7':  begin print,"N 8.7 filter"  & longwl=10.3 & shortwl= 7.2 & end
    'SiC':   begin print,"SiC filter"    & longwl=13.0 & shortwl=10.5 & end
    else: begin print,"Unknown filter: ", FrFilt & return & end
    endcase

    ; last scan is crap
    for f=0,nScan-1 do begin
        amplmax[f] = max(abs(fringe[*,f]))
        foufri[*,f]= abs( fft( fringe[*,f])) ^ 2
        totopd = abs( opd[scanLength-1,f] - opd[0,f]) * 1e6
        lowfreq = floor(totopd/longwl+0.5)
        highfreq= floor(totopd/shortwl+0.5)
        if (highfreq gt scanLength/2) then highfreq= scanLength/2
        ;print, totopd/13.,"...",totopd/7.7
        amplfou[f] = 2. * sqrt(total( foufri[ lowfreq:highfreq, f]))
                                ;print,ampl[f]
    endfor

  if not Keyword_set(nofou) then begin
      fringe_ampl = max(amplfou)
  endif else begin
      fringe_ampl = max(amplmax)
  endelse

  hist = histogram(amplfou,NBINS=40,OMIN=hmin,OMAX=hmax)
  xhist= findgen(40) * (hmax-hmin)/40. + hmin

  if NOT keyword_set(threshold) then threshold= hmax/2.

  goodthresh= threshold & oldgthres = 0 & Ngood = 0
  badthresh = threshold & oldbthres = 0 & Nbad  = 0

  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

  screensz = get_screen_size()

  ; Create a base widget containing a draw widget and a sub-base
  base  = Widget_Base(Title="Midivisi", Space=0, /COLUMN, /BASE_ALIGN_LEFT)
  fringe_l= Widget_Label(base, Value= "Fringefile: "+fringefile)
  photA_l = Widget_Label(base, Value= "  Photfile: "+photfileA+", Maskfile: "+maskfile)
  if N_Params() gt 2  then $
    photB_l = Widget_Label(base,Value="  Photfile: "+photfileB)

  topdraw  = Widget_Draw(base, XSIZE=screensz[0]-16, YSIZE=screensz[1]/2-40)

  base2 = Widget_Base(base, Space=0, /ROW)
  lftdraw= Widget_Draw(base2, XSIZE=(screensz[0]-200)/2, YSIZE=screensz[1]/2-80)
  bbase  = Widget_Base(base2, Space=0, /Column, /Align_Top, /BASE_align_center)
  rgtdraw= Widget_Draw(base2, XSIZE=(screensz[0]-200)/2, YSIZE=screensz[1]/2-80,$
                       /BUTTON_EVENT, /MOTION_EVENT)

  objectl= Widget_Label(bbase, Value="Object name: "+Object)
  phfiltl= Widget_Label(bbase, Value="Photometric Filter: "+PhFilt)
  frfiltl= Widget_Label(bbase, Value="Fringe Filter: "+FrFilt)
  scanlnl= Widget_Label(bbase, Value="Scanlength: "+strtrim(string(scanlength),2)+$
                       			" => "+strtrim(string(nScan),2)+" scans")
  beaml  = Widget_Label(bbase, Value="Beam is "+beam)
  fluxstr= string( FluxA1, FluxA2, Format='("A: ",G0.3,", ",G0.3," ph/sec")')
  fluxAl = Widget_Label(bbase, Value=fluxstr)
  fluxstr= string( FluxB1, FluxB2, Format='("B: ",G0.3,", ",G0.3," ph/sec")')
  fluxBl = Widget_Label(bbase, Value=fluxstr)

  goodthl= Widget_Label(bbase, Value="Good threshold:"+string(goodthresh))
  badthl = Widget_Label(bbase, Value=" Bad threshold:"+string( badthresh))

  sigamp = Widget_Label(bbase, Value="Mean signal ampl. ????????")
  noiamp = Widget_Label(bbase, Value="Mean noise  ampl. ????????")
  corramp= Widget_Label(bbase, Value="Corrected amplit. ????????")
  corrflx= Widget_Label(bbase, Value="Correlated Flux ??????????")
  visibi = Widget_Label(bbase, Value="VISIBILITY = 0.1234+-0.1234",/Align_Center)

  frimov = Widget_Button(bbase, Value="Fringe Movie", XSize=200-24, Ysize=36)
  foumov = Widget_Button(bbase, Value="Fourier Movie",XSize=200-24, Ysize=36)
  print  = Widget_Button(bbase, Value="Hardcopy", XSize=200-24, Ysize=36)
  wrtlog = Widget_Button(bbase, Value="Write to log", XSize=200-24, Ysize=36)
  quit   = Widget_Button(bbase, Value="Quit", XSize=200-24, Ysize=36)

  WIDGET_CONTROL, base, /REALIZE
  WIDGET_CONTROL, topdraw, GET_VALUE=topdrawID
  WIDGET_CONTROL, lftdraw, GET_VALUE=lftdrawID
  WIDGET_CONTROL, rgtdraw, GET_VALUE=rgtdrawID

  ;; now draw the static stuff

  wset, topdrawID
  !p.multi= [0, 0, 4, 0, 0]
  !p.charsize= 1.7
  xmidivisi_plot_static
  multi2 = !P.multi
  !p.charsize= 1.0

  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  meanramp = fltarr(40)
  noiseramp= fltarr(40)

  for i=0,N_elements(xhist)-1 do begin
        thres = xhist[i]
        goodfringes= where(amplfou gt thres, Ngood)
        meanramp[i]= total(amplfou[goodfringes])/Ngood
        badfringes = where(amplfou lt thres, Nbad)
        if Nbad gt 0 then noiseramp[i]= total(amplfou[badfringes])/Nbad
        ;print,"Threshold:",thres," => mean",meanramp[i]
  endfor

  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

  st = { topdraw: topdraw, topdrawID: topdrawID, multi: multi2, $
         lftdraw: lftdraw, lftdrawID: lftdrawID, $
         rgtdraw: rgtdraw, rgtdrawID: rgtdrawID, $
         goodthl: goodthl, badthl: badthl, $
         sigamp: sigamp, noiamp: noiamp, corramp: corramp, corrflx: corrflx, visibi: visibi,$
         print: print, frimov: frimov, foumov: foumov, wrtlog: wrtlog, quit: quit, $
         PhFilt: PhFilt, FrFilt: FrFilt, Beam: Beam, DIT: DIT, $
         FluxA1: FluxA1, FluxA2: FluxA2, FluxB1: FluxB1, FluxB2: FluxB2 }

  WIDGET_CONTROL, base, SET_UVALUE=st

  ; trigger some event to draw dynamic stuff
  WIDGET_CONTROL, topdraw, TIMER=0.0
  print,"starting xmanager"
  XMANAGER, 'xmidivisi', base, /NO_BLOCK

  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


end
