/*
 * Copyright 2005, 2006 University of Leiden.
 *
 * This file is part of MIA+EWS.
 *
 * MIA+EWS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * MIA+EWS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MIA; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#ifndef MINRTS_FILTER_UTIL_H
#define MINRTS_FILTER_UTIL_H
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <math.h>
#define REALPOS 0
#define REALSYM 1
#define IMAGINARY 2
typedef struct 
{
  int nData;
  int type; /* 0=REAL, 1=COMPLEX, 2=AMPPHASE */
  float *trans; /* filter transmission */
  float *spFreq;  /* spatial frequency in meters^-1 
                     (wave number is spFreq/2pi) */
} minrtsFilter;

void minrtsMinMax(int nData, float *data, float *max, float *min,
int *maxPos, int *minPos);
void minrtsMoments(int nData, float *data, float *mean, float *rms);
void minrtsAbs(int nData, float *data);
minrtsFilter *minrtsMakeFilter (int nData, float *spFreq, float *trans);
minrtsFilter *minrtsMakeFilterFromFile (char *fileName, int *ierr);
float *minrtsFilterInterp (minrtsFilter *filt, int nWave, float *spFreq);
float *minrtsFilterComplexFilter (minrtsFilter *filt, int nWave, 
   float *spFreq);
void minrtsKillFilter (minrtsFilter *filt );
float *minrtsSpline(int nX, float *x, float *y, int nT, float *t, float sigma);
void minrtsFilterWidth(minrtsFilter *filt, float *mean, float *rms);
void minrtsHeapSort(long n, float *d );
long * minrtsHeapSortI(long n, float *d );
void minrtsBoxSmooth(long n, float *inData, float *outData, int BoxSize );
#endif /* MINRTS_FILTER_UTIL_H */

